<template>
    <div class="the-editor-image-dialog">
        <VueDialog ref="dialog">
            <div>
                <label for="image-upload">Upload Image</label>
                <input type="file" id="image-upload" @change="uploadImage" />
            </div>
        </VueDialog>
    </div>
</template>

<script setup lang="ts">
import VueDialog from './VueDialog.vue';
import { ref } from 'vue'
import type { TheEditor } from '../TheEditor';

const editor = ref<TheEditor|undefined>()
const dialog = ref<InstanceType<typeof VueDialog>>()
const uploadImage = async (e: Event) => {
    // Load the image into a File object
    e.preventDefault
    let file = (e.target as HTMLInputElement).files?.[0]
    // Check if the file is an image
    if (!file || !file.type.startsWith('image/')) {
        alert('Please select an image file')
        return
    }
    let url = await editor.value?.extensionManager.extensions.find(ex => ex.name == 'image')?.options?.uploadImage(file)
    editor.value?.chain().setImage({src: url}).run()
    dialog.value?.close()
}
const openDialog = (ed:TheEditor) => {
    editor.value = ed
    dialog.value?.open()
}

defineExpose({
    openDialog
})


</script>